Subject: bug#74496: 30.0.91; fullscreen frame set with F11 is shifted when ctwm restarts

From: Van Ly <[email-masked]>
Date: Mon, 09 Dec 2024 11:11:40 +0000

martin rudalics <[email-masked]> writes:

>  > Should I build the gtk-3 variant to check the scroll bars are broken?
>
> If you find the time, please do.  It's a problem we should mention in
> etc/PROBLEMS so people using CWTM will build with Lucid or Motif
> instead.  Here the inner geometry of frames is also broken in the sense
> that mouse clicks in the left fringe are no more detected if there is a
> scroll bar on the left of that fringe (in another Emacs window).  So
> it's not a purely aesthetic problem here either.

When I click on the left fringe, the echo area says,

     <left-fringe><mouse-1> is undefined

where the foreground windowframe is regular size and immediately below
the windowframe is fullheight.

At the transition point when all frame decorations disappear in the
course of ctwm restart, it looks as though the frame translates in the
northwest direction then goes back when the decorations re-appear.

Normally, I don't use the tool bar and make it invisible, here I see the
toolbar has all button icons except for icon+save and icon+undo.

Mousing around to reproduce your observations, I found the toolbar would
flash to all buttons being icon+text when clicking on the scrollbar area
to scroll.  But at the next emacs session I wasn't able to reproduce
this glitch.

Nothing stands out as misbehaving around the scrollbars.  Normally, I
hide the scrollbar.

The following are window frame attributes before and after ctwm restart.

;; (setq-default frame-resize-pixelwise t) => t
;; windowframe is at fullheight

29.4 gtk-3 before ctwm restart

xwininfo: Window id: 0x340001e "*scratch* - GNU Emacs at xxx"

  Absolute upper-left X:  524
  Absolute upper-left Y:  3
  Relative upper-left X:  0
  Relative upper-left Y:  0
  Width: 672
  Height: 1069
  Depth: 32
  Visual: 0x8d
  Visual Class: TrueColor
  Border width: 0
  Class: InputOutput
  Colormap: 0x340001d (not installed)
  Bit Gravity State: NorthWestGravity
  Window Gravity State: NorthWestGravity
  Backing Store State: NotUseful
  Save Under State: no
  Map State: IsViewable
  Override Redirect State: no
  Corners:  +524+3  -724+3  -724-8  +524-8
  -geometry 79x58+521+0

(frame-geometry) =>
((outer-position 521 . 0) (outer-size 672 . 1069)
 (external-border-size -3 . -3) (outer-border-width . 0)
 (title-bar-size 0 . 6) (menu-bar-external . t)
 (menu-bar-size 672 . 25) (tab-bar-size 0 . 0)
 (tool-bar-external . t) (tool-bar-position . top)
 (tool-bar-size 672 . 41) (internal-border-width . 0))

29.4 gtk-3 after ctwm restart

xwininfo: Window id: 0x340001e "*scratch* - GNU Emacs at xxx"

  Absolute upper-left X:  524
  Absolute upper-left Y:  3
  Relative upper-left X:  0
  Relative upper-left Y:  0
  Width: 672
  Height: 1069
  Depth: 32
  Visual: 0x8d
  Visual Class: TrueColor
  Border width: 0
  Class: InputOutput
  Colormap: 0x340001d (not installed)
  Bit Gravity State: NorthWestGravity
  Window Gravity State: NorthWestGravity
  Backing Store State: NotUseful
  Save Under State: no
  Map State: IsViewable
  Override Redirect State: no
  Corners:  +524+3  -724+3  -724-8  +524-8
  -geometry 79x58+521+0

(frame-geometry) =>
((outer-position 521 . 0) (outer-size 672 . 1069)
 (external-border-size -3 . -3) (outer-border-width . 0)
 (title-bar-size 0 . 6) (menu-bar-external . t)
 (menu-bar-size 672 . 25) (tab-bar-size 0 . 0)
 (tool-bar-external . t) (tool-bar-position . top)
 (tool-bar-size 672 . 41) (internal-border-width . 0))

-- 
vl